# HelloWorld Sample Application

This is a Hello World-like sample application for the BlackBerry PlayBook tablet that uses HTML5, JavaScript, and CSS. This application displays an image and a button. When users click the button, their GPS coordinates are returned and displayed on the screen along with some location-related information. 

This application was created for the [Creating your First application tutorial](https://developer.blackberry.com/html5/documentation/ww_tutorials/tutorial_create_first_app_intro_1969476_11.html).

**Applies To**

* [BlackBerry WebWorks SDK for Tablet OS](https://developer.blackberry.com/html5/)

**Author(s)** 

* [Adam Stanley](https://github.com/astanley)
* [Barb Paduch](https://github.com/bpaduch)

**Dependencies**

1. The images used in this sample application (icon.png and helloWorld.png) were created by the Multimedia team at RIM.  These images are available for use under the Apache2 license.

**To contribute code to this repository you must be [signed up as an official contributor](http://blackberry.github.com/howToContribute.html).**


## How to Build

To build the HelloWorld sample application, complete the following steps:

1. Click on the **Downloads** tab above.
2. Select **Download as zip** (Windows) or **Download as tar.gz** (Mac) and save the downloaded file to your local machine.
3. Create a new folder on your local machine named **helloworld** (for example, **C:\Documents and Settings\User\WebWorks\HelloWorld** (Windows) or **~/WebWorks/HelloWorld** (Mac).
4. Open the downloaded ZIP file from step 2 and extract the contents **from inside the zipped HelloWorld folder** to your local **HelloWorld** folder from step 3.  This ensures that the necessary application assets, such as **config.xml**, are correctly located at the top level of the local **HelloWorld** folder (e.g. **~/WebWorks/HelloWorld/config.xml**).
5. Using the **[Ripple Mobile Emulator](http://developer.blackberry.com/html5/download/ripple)** and either the **[BlackBerry WebWorks SDK for Smartphone](http://developer.blackberry.com/html5/download/sdk)** or the **[BlackBerry WebWorks SDK for Tablet OS](http://developer.blackberry.com/html5/download/sdk)**, package the contents of your local **HelloWorld** folder into a BlackBerry application.  Enter the project root settings field as the local folder created in step 3, and the archive name settings field as **HelloWorld**.


## More Info

* [BlackBerry HTML5 WebWorks](https://developer.blackberry.com/html5/) - Downloads, Getting Started guides, samples, code signing keys.
* [BlackBerry WebWorks Development Guides] (https://developer.blackberry.com/html5/documentation/)
* [BlackBerry WebWorks Community Forums](http://supportforums.blackberry.com/t5/Web-and-WebWorks-Development/bd-p/browser_dev)
* [BlackBerry Open Source WebWorks Contributions Forums](http://supportforums.blackberry.com/t5/BlackBerry-WebWorks/bd-p/ww_con)

## Contributing Changes

Please see the [README](https://github.com/blackberry/WebWorks-Samples) of the WebWorks-Samples repository for instructions on how to add new Samples or make modifications to existing Samples.


## Bug Reporting and Feature Requests

If you find a bug in a Sample, or have an enhancement request, simply file an [Issue](https://github.com/blackberry/WebWorks-Samples/issues) for the Sample.


## Disclaimer

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
