# WebWorks Samples Repository 

The _**WebWorks-Samples**_ repository is where official WebWorks samples for BlackBerry Smartphone and Tablet OS are hosted. For Community Samples, please refer to the [WebWorks-Community-Samples Repository](repo:WebWorks-Community-Samples).

All APIs shared in this repository are Open Source under the  [Apache 2.0 License](http://www.apache.org/licenses/LICENSE-2.0.html)

**To contribute code to this repository you must be [signed up as an official contributor](https://github.com/blackberry/WebWorks/wiki/How-to-Contribute).**


## Code Organization

Each Sample added to the repository should be placed in its own directory.  Make sure you name the directory something simple, yet descriptive.  Each Sample must also have a README.md file at the root of its directory.
This README needs to indicate the Author of the API, devices and OS versions it was tested on, and information about the application and how to use it.


## Contributing Samples

To add new Samples or make modifications to existing Samples:

1. Fork the **WebWorks-Samples** repository
2. Make the changes/additions to your fork
3. Send a pull request from your fork back to the **WebWorks-Samples** repository
4. If you made changes to code which you are NOT the owner, send a message via github messages to the Author(s) of the Sample to indicate that you have a pull request for them to review
5. If you made changes to code which you own, send a message via github messages to one of the Committers listed below to have your code merged

## Governence

The code for each of the WebWorks Samples is managed by the author of the Sample.  When a pull request comes in for a specific Sample the Author(s) should be notified by the pull request owner to perform a code review.  When the author
indicates that the pull request is ready to be merged (via a comment on the pull request) they can then send a message to a committer through github messages to have the changes merged.

If there are more than one Author for a specific Sample, only one Author is required to indicate that the pull request is ready.  If there's more than one Sample affected by a pull request, at least one Author from each Sample must code review
the pull request and indicate that it is ready to be merged before the pull request can be merged.

If the Author of the pull request is the actual owner of the Sample, then the Author should send a message to a committer via github messages to have their changes merged.

**Ownership Transfer:**
An Author can transfer ownership to another Author by opening up an [Issue](https://github.com/blackberry/WebWorks-Samples/issues) where both the original Author requests ownership to be transfered to the new Author, and the new Author agrees to take ownership of the code.  
The README for the Sample should be updated to indicate the new Author.

**Repository Committers** 

* [Jeffrey Heifetz](https://github.com/jeffheifetz)
* [Alex Babut](https://github.com/ababut)
* [Adam Stanley](https://github.com/adamstanley)
* [Ken Wallis](https://github.com/kwallis)
* [Chris DelCol](https://github.com/cdelcol)
* [Tim Neil](https://github.com/tneil)
* [Tim Windsor](https://github.com/timwindsor)

## Bug Reporting and Feature Requests

If you find a bug in a Sample, or have an enhancement request, simply file an [Issue](https://github.com/blackberry/WebWorks-Samples/issues) for the Sample.

## Disclaimer

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

