# Weather Sample Application

View a complete WebWorks enabled HTML5 sample application with full source to the UI, application logic and JavaScript extensions used. THis application showcases the use of both HTML5 Database and Geolocation APIs.

The sample code for this application is Open Source under the [Apache 2.0 License](http://www.apache.org/licenses/LICENSE-2.0.html).


**Applies To**

* [BlackBerry WebWorks SDK for Smartphones](https://bdsc.webapps.blackberry.com/html5/download/sdk)


**Author(s)** 

* LionsBridge


**Dependencies**

1. In order to use the spinner on the Input Control Examples [you require the assiciated SpinnerControl extension](https://github.com/blackberry/WebWorks-Community-APIs/tree/master/Smartphone/SpinnerControl) 

**Known Issues**

* None

**Tested On**

* BlackBerry Torch 9810 v7.0.0.353
* BlackBerry Curve 9330 v6.0.0.436
* BlackBerry Bold  9650 v5.0.0.601

**To contribute code to this repository you must be [signed up as an official contributor](http://blackberry.github.com/howToContribute.html).**


## How to Build

To build this sample application:

1. Click on the **Downloads** button at the top right of this screen.
2. Select **Download.zip** and save the downloaded file to your local machine.
3. Create a new folder on your local machine named **weather** (e.g. **c:\webworks\weather**).
4. Open the downloaded ZIP file from step 2 and **extract the contents from inside the top level folder** to your new **weather** folder.  This ensures that the necessary application assets, such as **config.xml**, are correctly located at the top level of the **weather** folder (e.g. **c:\webworks\weather\config.xml**).
5. Using an achiving utility (e.g. WinZip or 7-zip), package the contents of your **c:\webworks\weather** folder into a ZIP archive named **weather.zip**.  This archive should have the application assets (not a folder containing the application assets) at its top level.
6. Using the **[BlackBerry WebWorks SDK for Smartphones](https://bdsc.webapps.blackberry.com/html5/download/sdk)**, package the **weather.zip** archive into a BlackBerry Tablet OS application using the following command line: **bbwp c:\webworks\weather\weather.zip**


## More Info

* [BlackBerry WebWorks SDK for Tablet OS](http://us.blackberry.com/developers/tablet/webworks.jsp) - Getting Started guides, SDK downloads, code signing keys.
* [BlackBerry WebWorks SDK for Smartphones](http://us.blackberry.com/developers/browserdev/widgetsdk.jsp) - Getting Started guides, SDK downloads, code signing keys.
* [BlackBerry WebWorks SDK for Tablets - Development Guides] (http://docs.blackberry.com/en/developers/deliverables/30182/)
* [BlackBerry WebWorks SDK for Smartphones - Development Guides] (http://docs.blackberry.com/en/developers/subcategories/?userType=21&category=BlackBerry+WebWorks+for+Smartphones)
* [BlackBerry WebWorks Community Forums](http://supportforums.blackberry.com/t5/Web-and-WebWorks-Development/bd-p/browser_dev)
* [BlackBerry Open Source WebWorks Contributions Forums](http://supportforums.blackberry.com/t5/BlackBerry-WebWorks/bd-p/ww_con)


## Contributing Changes

Please see the [README](https://github.com/blackberry/WebWorks-Samples) of the WebWorks-Samples repository for instructions on how to add new Samples or make modifications to existing Samples.


## Bug Reporting and Feature Requests

If you find a bug in a Sample, or have an enhancement request, simply file an [Issue](https://github.com/blackberry/WebWorks-Samples/issues) for the Sample.


## Disclaimer

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
