/*
 * Copyright 2011 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
 function setPercent(gauge, percent) {
	var percentValue = percent / 100;
	var gaugeWidth = percentValue * gauge.parentNode.clientWidth;
	gauge.style.width = gaugeWidth + 'px';
}

var percent;
var increment;
var gauge;
function incrementPercent(tx, rs) {
	setPercent(gauge, percent += increment);
}

function progressComplete(tx, rs) {
	setPercent(gauge, 100);
	document.getElementById('tblGauge').style.display = 'none';
	document.getElementById('tblAddLocation').style.display = 'block';
	document.getElementById("txtcityzip").focus();
	setFocusToElement('dummyDivAddLocation', 'txtcityzip');
}

/*
 * Predefined Stations List
 */
function insertDefaultStations(tx)
{
	try
	{
		document.getElementById('tblGauge').style.display = 'block';
		document.getElementById('tblAddLocation').style.display = 'none';
		if (blackberry.ui.menu.getMenuItems().length > 0)
			blackberry.ui.menu.clearMenuItems();

		gauge = document.getElementById('gauge0');
		percent = 0;
		setPercent(gauge, 0);

		var stationsList = ["insert into StationList (latitude, longitude, xml_url) values (-22.017, 166.217, 'NWWW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (-21.233, -175.15, 'NFTF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (-21.2, -159.817, 'NCRG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (-19.067, -169.917, 'NIUE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (-18.583, -173.95, 'NFTV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (-18.05, 178.567, 'NFNA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (-17.75, 177.45, 'NFFN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (-17.55, -149.617, 'NTAA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (-14.333, -170.717, 'NSTU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (-13.817, -172, 'NSFA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (-8.533, 179.217, 'NGFU');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (1.35, 172.917, 'NGTA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (5.333, 163.033, 'PTSA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (6.95, 158.25, 'PTTP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (6.97, 158.22, 'PTPN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (7.06, 171.27, 'PKMR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (7.083, 171.383, 'PKMJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (7.27, 134.45, 'PTKR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (7.33, 134.48, 'PTRO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (7.47, 151.85, 'PTKK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (8.733, 167.733, 'PKWA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (9.483, 138.083, 'PTYA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (10.617, -61.35, 'TTPP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (11.15, -60.833, 'TTCP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (12, -61.783, 'TGPY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (12.15, -68.283, 'TNCB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (12.2, -68.967, 'TNCC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (12.5, -70.017, 'TNCA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (13.067, -59.483, 'TBPB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (13.133, -61.2, 'TVSV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (13.48, 144.8, 'PGUM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (13.58, 144.93, 'PGUA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (13.75, -60.95, 'TLPL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (14.017, -61, 'TLPC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (14.18, 145.25, 'PGRO');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (14.6, -61, 'TFFF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (14.97, 145.6, 'PGWT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (15.12, 145.73, 'PGSN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (15.533, -61.4, 'TDCF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (15.533, -61.3, 'TDPD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (16.267, -61.6, 'TFFR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (16.75, -62.167, 'TRPM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (17.117, -61.783, 'TAPA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (17.2, -62.583, 'TKPN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (17.3, -62.683, 'TKPK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (17.483, -62.983, 'TNCE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (17.7, -64.8, 'TISX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (18.02, -66.57, 'TJPS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (18.033, -63.117, 'TNCM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (18.2, -63.05, 'TQPF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (18.25, -65.633, 'TJNR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (18.27, -67.15, 'TJMZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (18.33, -64.97, 'TIST');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (18.43, -66, 'TJSJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (18.45, -64.533, 'TUPJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (18.5, -67.13, 'TJBQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (19.283, 166.5, 'PWAK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (19.65, -156, 'PHKO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (19.72, -155.07, 'PHTO');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (19.78, -155.55, 'PHSF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (20.78, -156.95, 'PHNY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (20.784, -156.014, 'PHHN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (20.9, -156.43, 'PHOG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (21.02, -156.63, 'PHJH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (21.03, -86.87, 'MMUN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (21.15, -157.1, 'PHMK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (21.32, -158.07, 'PHJR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (21.35, -157.93, 'PHNL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (21.45, -157.783, 'PHNG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (21.48, -158.03, 'PHHI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (21.98, -159.35, 'PHLI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (22.07, -159.78, 'PHBK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (24.55, -81.75, 'KEYW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (24.57, -81.68, 'KNQX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (24.74, -81.05, 'KMTH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (25.05, -77.467, 'MYNN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (25.48, -80.38, 'KHST');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (25.617, -80.417, 'KAMX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (25.65, -80.43, 'KTMB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (25.78, -80.32, 'KMIA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (25.9, -97.43, 'KBRO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (25.91, -80.28, 'KOPF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26, -80.24, 'KHWO');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (26.07, -80.15, 'KFLL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.0706, -97.1572, 'KSPL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.15, -81.77, 'KAPF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.159, -97.338, 'KPIL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.167, -97.967, 'KT65');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.18, -98.24, 'KMFE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.2, -80.17, 'KFXE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.23, -97.67, 'KHRL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.25, -80.11, 'KPMP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.38, -80.1, 'KBCT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.442, -98.129, 'KEBG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.54, -81.76, 'KRSW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.58, -81.87, 'KFMY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.68, -80.12, 'KPBI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.92, -81.99, 'KPGD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (26.9688, -99.2489, 'KAPY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.182, -80.221, 'KSUA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.207, -98.121, 'KBKS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.26, -80.85, 'KOBE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.333, -98.733, 'KHBV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.4, -82.55, 'KSRQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.5, -80.37, 'KFPR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.5, -97.817, 'KNQI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.54, -99.47, 'KLRD');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (27.65, -80.42, 'KVRB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.683, -97.283, 'KNGP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.74, -98.04, 'KALI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.767, -91.517, 'KXCN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.77, -97.5, 'KCRP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.77, -82.63, 'KSPG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.779, -97.691, 'KRBO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.817, -97.083, 'K2R8');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.817, -97.083, 'KRAS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.86, -82.52, 'KMCF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.91, -82.69, 'KPIE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.91, -97.21, 'KT43');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.91, -97.21, 'KTFP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.9156, -82.4493, 'KTPF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.95, -81.78, 'KBOW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (27.97, -82.53, 'KTPA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.0002, -82.1642, 'KPCM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.01, -82.35, 'KVDF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.04, -81.95, 'KLAL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.05, -81.75, 'KGIF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.083, -92.7, 'K3B6');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.083, -92.7, 'KE12');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.09, -97.05, 'KRKP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.11, -80.63, 'KMLB');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (28.22, -177.37, 'PMDY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.23, -80.6, 'KCOF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.29, -81.437, 'KISM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.3, -91.983, 'K7R8');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.32, -90.35, 'KS58');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.36, -97.79, 'K3R0');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.3619, -97.791, 'KBEA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.43, -81.32, 'KMCO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.45, -99.22, 'KCOT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.467, -93.733, 'KH08');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.4677, -80.5668, 'KXMR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.47, -82.45, 'KBKV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.52, -80.8, 'KTIX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.533, -90.983, 'KGSM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.55, -81.33, 'KORL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.62, -80.72, 'KTTS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.65, -96.667, 'KPKV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.72, -96.25, 'KPSX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.78, -81.24, 'KSFB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.82, -81.81, 'KLEE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.86, -96.92, 'KVCT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.95, -98.52, 'KPEZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.962, -81.97, 'KVVG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (28.973, -95.863, 'KBYY');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (29.05, -80.95, 'KEVB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.117, -91.867, 'KSRN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.12, -95.47, 'KLBX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.15, -93.35, 'KW60');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.18, -81.05, 'KDAB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.18, -82.22, 'KOCF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.211, -99.744, 'KUVA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.25, -96.117, 'KARM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.27, -94.87, 'KGLS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.3, -81.1, 'KOMN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.33, -98.47, 'KSSF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.333, -89.4, 'KBVE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.35, -89.433, 'K1B7');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.36, -99.16, 'KHDO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.367, -100.783, 'KDLF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.38, -100.92, 'KDRT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.383, -98.583, 'KSKF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.417, -90.3, 'K2GL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.4447, -90.2611, 'KGAO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.519, -95.242, 'KLVJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.533, -98.283, 'KRND');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.54, -98.47, 'KSAT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.57, -90.67, 'KHUM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.6, -91.3, 'KP92');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (29.62, -95.17, 'KEFD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.62, -95.65, 'KSGR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.64, -83.1, 'KCTY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.65, -95.28, 'KHOU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.68, -82.27, 'KGNV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.7, -91.1, 'K7R3');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.7, -93.95, 'KRPE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.709, -98.045, 'KBAZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.72, -91.33, 'KPTN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.728, -85.027, 'KAAF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.783, -92.133, 'K7R4');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.783, -93.3, 'K7R5');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.833, -90.017, 'KNBG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.9, -97.87, 'KHYI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.91, -96.95, 'K3T5');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.95, -94.02, 'KBPT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.95, -100.167, 'KECU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.97, -95.35, 'KIAH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.97, -81.33, 'KSGJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.98, -99.08, 'KERV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (29.98, -90.25, 'KMSY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.03, -91.88, 'KARA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.04, -90.03, 'KNEW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.067, -93.8, 'KORG');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (30.07, -83.57, 'K40J');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.07, -95.55, 'KDWH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.07, -85.59, 'KPAM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.12, -93.22, 'KLCH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.1693, -96.98, 'KGYB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.2, -97.68, 'KAUS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.2, -92, 'KLFT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.2, -85.68, 'KPFN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.214, -95.005, 'K6R3');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.217, -81.876, 'KVQQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.219, -96.374, 'K11R');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.22, -93.15, 'KCWF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.23, -81.68, 'KNIP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.244, -98.91, 'KT82');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.2896, -87.6718, 'KJKA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.32, -97.77, 'KATT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.33, -81.52, 'KCRG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.35, -89.82, 'KASD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.3582, -85.7956, 'KECP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.36, -95.41, 'KCXO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.36, -87.32, 'KNPA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.38, -104.02, 'KMRF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.384, -103.684, 'KE38');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.4, -86.47, 'KDTS');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (30.4, -89.07, 'KGPT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.4, -81.42, 'KNRB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.4, -88.483, 'KPGL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.4, -84.35, 'KTLH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.417, -88.917, 'KBIX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.422, -102.278, 'K6R6');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.43, -86.68, 'KHRT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.43, -81.7, 'KJAX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.46, -88.53, 'KPQL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.47, -87.2, 'KPNS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.48, -86.53, 'KVPS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.5, -99.77, 'KJCT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.517, -96.7, 'KRWV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.52, -90.42, 'KHDC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.54, -91.15, 'KBTR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.58, -96.37, 'KCLL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.583, -100.65, 'KSOA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.64, -88.07, 'KBFM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.68, -88.25, 'KMOB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.69, -97.69, 'KGTU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.72, -87.02, 'KNSE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.7353, -101.203, 'KOZA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.74, -98.23, 'KBMQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.74, -95.59, 'KUTS');",

		                    "insert into StationList (latitude, longitude, xml_url) values (30.7506, -92.6886, 'KACP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.7837, -98.662, 'KAQO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.79, -86.52, 'KCEW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.79, -83.28, 'KVLD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.8, -85.21, 'KMAI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.833, -93.333, 'KDRI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.872, -96.622, 'KLHB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.89, -94.03, 'KJAS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.91, -102.91, 'KFST');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.97, -84.63, 'KBGE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (30.97, -83.2, 'KVAD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31, -92.967, 'KBKB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.033, -86.317, 'K0J4');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.05, -93.183, 'KPOE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.067, -97.833, 'KGRK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.085, -83.803, 'KMGR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.09, -97.69, 'KILE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.1, -93, 'KDNK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.1062, -98.1959, 'KLZZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.15, -81.38, 'KBQK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.15, -97.717, 'KHLR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.15, -81.38, 'KSSI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.15, -97.42, 'KTPL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.18, -90.47, 'KMCB');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (31.183, -99.317, 'KBBD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.23, -94.75, 'KLFK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.25, -82.4, 'KAYS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.27, -89.25, 'KHBG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.283, -85.717, 'KOZR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.3069, -95.4036, 'KDKR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.317, -86.4, 'K79J');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.32, -85.45, 'KDHN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.33, -92.55, 'KAEX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.346, -86.654, 'KHEY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.37, -100.5, 'KSJT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.383, -103.5, 'KPEQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.3969, -84.895, 'KBIJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.397, -84.895, 'K11J');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.4, -93.283, 'KAQV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.4, -92.3, 'KESF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.417, -97.783, 'KGOP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.42, -87.04, 'KGZH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.42, -110.85, 'KOLS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.45, -109.6, 'KDUG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.47, -89.33, 'KPIB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.477, -82.861, 'KDQH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.49, -97.32, 'KPWG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.54, -84.18, 'KABY');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (31.54, -82.5, 'KAMG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.57, -94.7, 'KOCH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.58, -110.33, 'KFHU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.62, -97.22, 'KACT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.62, -91.25, 'KHEZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.633, -106.417, 'MMCS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.6659, -98.1486, 'KMNZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.733, -93.1, 'KIER');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.78, -95.706, 'KPSN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.79, -103.2, 'KINK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.8, -98.95, 'KBWD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.8, -106.4, 'KELP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.83, -104.8, 'KGDP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.8457, -86.6107, 'KPRN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.86, -86.01, 'KTOI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.869, -95.217, 'KJSO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.88, -81.57, 'KLHW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.917, -98.6, 'KMKN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.921, -102.392, 'KODO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (31.95, -102.18, 'KMAF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.03, -96.4, 'KCRS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.03, -81.15, 'KSVN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.033, -102.1, 'KMDD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.083, -97.097, 'KINJ');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (32.12, -110.93, 'KTUS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.14, -81.2, 'KSAV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.1417, -94.8517, 'KRFI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.18, -110.88, 'KDMA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.193, -82.372, 'KVDI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.213, -101.522, 'KBPG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.215, -98.178, 'KSEP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.232, -80.7, 'KHXD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.26, -107.7, 'KDMN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.3, -106.77, 'KLRU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.3, -86.4, 'KMGM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.33, -90.22, 'KHKS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.33, -90.08, 'KJAN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.34, -104.27, 'KCNM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.34, -85, 'KLSF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.34, -88.75, 'KMEI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.35, -97.433, 'KCPT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.35, -91.03, 'KTVR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.35, -95.4, 'KTYR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.367, -64.683, 'TXKF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.38, -94.71, 'KGGG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.383, -86.367, 'KMXF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.39, -114.37, 'KNYL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.417, -99.85, 'KDYS');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (32.43, -99.68, 'KABI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.444, -97.817, 'KGDJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.45, -93.83, 'KSHV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.456, -96.912, 'KJWY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.47, -100.47, 'KSWW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.48, -80.72, 'KNBC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.482, -81.737, 'KTBR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.5, -93.683, 'KBAD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.51, -97.3, 'KFWS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.51, -92.04, 'KMLU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.5144, -92.5883, 'KRSN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.53, -84.93, 'KCSG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.53, -93.75, 'KDTN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.55, -88.567, 'KNMM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.567, -82.983, 'KDBN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.579, -96.719, 'KLNC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.58, -117.12, 'KNRS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.58, -116.98, 'KSDM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.62, -85.44, 'KAUO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.62, -116.47, 'KCZZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.64, -108.16, 'KSVC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.64, -83.6, 'KWRB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.645, -81.596, 'KJYL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.664, -97.096, 'KGKY');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (32.667, -102.65, 'KGNC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.667, -114.6, 'KYUM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.69, -103.2, 'KHOB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.69, -96.87, 'KRBD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.693, -100.95, 'KSNK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.699, -97.047, 'KGPM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.699, -94.948, 'KJXI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.71, -83.65, 'KMCN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.71, -117.2, 'KNZY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.71, -96.27, 'KTRL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.719, -98.891, 'KBKD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.73, -117.17, 'KSAN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.742, -95.496, 'KJDD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.747, -96.53, 'KHQZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.7558, -91.8806, 'K2F8');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.767, -97.45, 'KNFW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.79, -98.07, 'KMWL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.83, -97.35, 'KFTW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.83, -117.13, 'KMYF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.83, -115.68, 'KNJK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.83, -116.97, 'KSEE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.84, -105.99, 'KALM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.84, -115.57, 'KIPL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.85, -104.47, 'KATS');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (32.85, -109.64, 'KSAD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.86, -96.85, 'KDAL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.86, -106.1, 'KHMN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.88, -117.15, 'KNKX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.89, -112.72, 'KGBN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.9, -87.25, 'KCKL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.91, -80.03, 'KCHS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.91, -97.03, 'KDFW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.915, -85.963, 'KALX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.955, -84.263, 'KOPN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.96, -111.77, 'KCGZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.98, -96.83, 'KADS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (32.98, -97.32, 'KAFW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.009, -85.073, 'KLGC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.03, -118.58, 'KNUC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.04, -116.91, 'KRNM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.0634, -80.2793, 'KDYB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.08, -96.07, 'KGVT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.096, -94.962, 'KOSA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.11, -98.555, 'KRPH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.14, -117.28, 'KCRQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.15, -83.233, 'KMLJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.167, -95.617, 'KSLR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.167, -97.833, 'KXBP');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (33.18, -86.78, 'KEET');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.18, -96.59, 'KTKI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.2, -97.18, 'KDTO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.219, -117.349, 'KOKB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.23, -92.8, 'KELD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.23, -87.62, 'KTCL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.23, -107.27, 'KTCS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.255, -97.581, 'KLUD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.26, -119.45, 'KNSI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.27, -111.81, 'KCHD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.3, -111.67, 'KIWA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.3, -117.35, 'KNFG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.31, -84.77, 'KCCO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.31, -104.51, 'KROW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.35, -84.56, 'KFFC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.36, -105.67, 'KSRR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.38, -81.97, 'KAGS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.41, -118.42, 'KAVX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.42, -112.39, 'KGYR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.44, -112.02, 'KPHX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.46, -111.73, 'KFFZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.46, -88.58, 'KGTR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.46, -94, 'KTXK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.47, -82.03, 'KDNL');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (33.47, -80.85, 'KOGB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.48, -90.98, 'KGLH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.51, -90.08, 'KGWO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.53, -112.3, 'KGEU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.53, -82.516, 'KHQU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.56, -86.75, 'KBHM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.59, -85.85, 'KANB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.59, -112.37, 'KLUF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.593, -95.064, 'KLBR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.6, -83.133, 'K3J7');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.6017, -97.7756, 'K0F2');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.61, -111.91, 'KSDL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.62, -114.72, 'KBLH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.623, -92.763, 'KCDH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.633, -88.45, 'KCBM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.64, -91.75, 'KLLQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.64, -95.45, 'KPRX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.64, -116.17, 'KTRM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.652, -97.2, 'KGLE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.66, -84.42, 'KATL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.66, -101.82, 'KLBB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.68, -117.88, 'KSNA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.69, -112.08, 'KDVT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.69, -78.93, 'KMYR');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (33.717, -96.667, 'KF39');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.73, -96.67, 'KGYI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.78, -84.52, 'KFTY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.78, -82.82, 'KIIY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.79, -118.05, 'KSLI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.8, -118.33, 'KTOA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.81, -78.72, 'KCRE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.83, -118.15, 'KLGB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.84, -116.5, 'KPSP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.858, -98.49, 'KCWC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.858, -98.49, 'KT47');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.87, -117.57, 'KAJO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.87, -117.98, 'KFUL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.88, -84.3, 'KPDK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.89, -117.27, 'KRIV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.9, -94.867, 'K4O4');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.93, -118.34, 'KHHR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.93, -84.52, 'KMGE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.93, -80.8, 'KMMT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.93, -78.07, 'KSUT');",
		                    "insert into StationList (latitude, longitude, xml_url) values (33.94, -96.39, 'KDUA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.94, -118.4, 'KLAX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.95, -117.45, 'KRAL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.96, -83.32, 'KAHN');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (33.96, -81.12, 'KCAE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.97, -117.64, 'KCNO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.97, -86.09, 'KGAD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.978, -83.962, 'KLZU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.98, -98.48, 'KSPS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.98, -80.47, 'KSSC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.982, -83.668, 'KWDR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (33.99, -81, 'KCUB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.013, -84.599, 'KRYY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.02, -118.28, 'KCQT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.0225, -106.903, 'KONM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.03, -118.45, 'KSMO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.05, -94.4, 'KDEQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.06, -117.6, 'KONT');", 
		                    /*			"insert into StationList (latitude, longitude, xml_url) values (34.09, -118.03, 'KEMT');",  Current Weather Data Not available to the station */ 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.095, -82.816, 'K27A');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.1, -93.07, 'KM89');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.11, -105.68, 'K4CR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.11, -117.78, 'KPOC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.12, -119.12, 'KNTD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.13, -84.85, 'KVPC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.15, -97.12, 'K1F0');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.168, -101.717, 'KPVW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.18, -91.93, 'KPBF');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (34.19, -79.72, 'KFLO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.2, -118.36, 'KBUR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.21, -119.09, 'KCMA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.21, -119.2, 'KOXR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.21, -118.49, 'KVNY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.226, -99.284, 'KF05');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.2291, -86.2558, 'K8A0');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.233, -82.15, 'KGRD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.233, -118.067, 'KMWS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.2568, -111.339, 'KPAN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.26, -83.83, 'KGVL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.26, -118.41, 'KWHP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.269, -86.858, 'K3A1');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.27, -116.85, 'KL35');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.28, -87.6, 'K1M4');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.28, -78.71, 'KCPC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.28, -77.92, 'KILM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.28, -110, 'KSOW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.28, -88.77, 'KTUP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.3, -84.417, 'K47A');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.3, -97.02, 'KADM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.3, -116.17, 'KNXP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.35, -98.98, 'KFDR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.36, -85.17, 'KRMG');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (34.39, -103.32, 'KCVS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.4, -118.6, 'K3A6');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.4, -96.15, 'KAQR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.4031, -80.1192, 'KHVS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.43, -103.08, 'KCVN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.44, -100.28, 'KCDS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.44, -119.83, 'KSBA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.45, -79.883, 'KUDG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.467, -85.717, 'K4A9');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.47, -97.96, 'KDUC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.48, -93.1, 'KHOT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.51, -82.72, 'KAND');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.52, -109.38, 'KSJN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.547, -93.578, 'KMWT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.55, -93.583, 'KMEZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.57, -98.42, 'KLAW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.583, -117.383, 'KVCV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.6, -120.067, 'KIZA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.602, -78.579, 'KEYF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.61, -79.06, 'KLBT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.61, -91.57, 'KSGT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.6217, -79.7344, 'KBBP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.63, -118.08, 'KPMD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.645, -106.834, 'KE80');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (34.65, -98.383, 'KFSI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.65, -112.42, 'KPRC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.66, -86.94, 'KDCU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.66, -86.77, 'KHSV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.667, -82.867, 'KCEU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.67, -120.47, 'KLPC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.683, -86.683, 'KHUA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.683, -90.333, 'KM97');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.6831, -90.3472, 'KUTA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.7, -99.333, 'KAXS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.71, -77.43, 'KNCA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.711, -97.223, 'KPVJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.717, -76.65, 'KMRH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.717, -120.567, 'KXVW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.72, -84.87, 'KDNN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.73, -92.23, 'KLIT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.73, -120.55, 'KVBG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.73, -118.22, 'KWJF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.75, -82.367, 'KGYH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.75, -87.61, 'KMSL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.76, -118.73, 'KSDB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.78, -114.62, 'KEED');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.79, -79.37, 'KMEB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.8, -99, 'KLTS');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (34.804, -96.671, 'KADH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.83, -77.62, 'KOAJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.8486, -111.788, 'KSEZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.85, -82.35, 'KGMU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.85, -86.55, 'KM82');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.8544, -83.9973, 'KDZJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.86, -102.33, 'KHRX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.86, -86.56, 'KMDQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.86, -76.88, 'KNKT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.88, -116.78, 'KDAG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.883, -79.75, 'K45J');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.89, -95.78, 'KMLC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.91, -117.87, 'KEDW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.91, -82.22, 'KGSP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.91, -120.45, 'KSMX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.917, -92.15, 'KLRF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.98, -106.05, 'K4MY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.98, -89.79, 'KOLV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.983, -117.867, 'K9L2');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.983, -78.367, 'KCTZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.984, -81.056, 'KUZA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (34.99, -78.88, 'KFAY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35, -105.66, 'KCQC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35, -77.98, 'KDPL');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (35.01, -99.05, 'KHBR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.017, -80.617, 'KEQY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.022, -94.621, 'KRKR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.03, -110.73, 'KINW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.033, -79.5, 'KHFF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.04, -85.2, 'KCHA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.04, -89.98, 'KMEM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.05, -106.62, 'KABQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.07, -118.16, 'KMHV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.09, -77.05, 'KEWN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.1, -97.97, 'KCHK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.11, -114.5, 'KIFP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.135, -90.234, 'KAWM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.14, -78.93, 'KFBG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.14, -111.67, 'KFLG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.15, -106.8, 'KAEG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.18, -107.9, 'KGNT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.18, -79.02, 'KPOB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.19, -83.86, 'KRHP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.19, -103.6, 'KTCC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.2, -81.15, 'KAKH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.21, -80.94, 'KCLT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.217, -83.417, 'K1A5');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.23, -101.7, 'KAMA');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (35.23, -75.62, 'KHSE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.24, -120.64, 'KSBP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.24, -79.41, 'KSOP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.246, -97.472, 'KOUN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.25, -81.6, 'KEHO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.26, -93.09, 'KRUE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.2744, -96.675, 'KSRE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.28, -113.95, 'KIGM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.3055, -112.194, 'KCMR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.33, -77.63, 'KISO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.34, -94.37, 'KFSM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.34, -77.97, 'KGSB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.36, -99.2, 'KCSM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.36, -89.87, 'KNQA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.36, -96.94, 'KSNL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.38, -78.73, 'KHRJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.39, -80.71, 'KJQF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.41, -97.6, 'KOKC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.417, -97.383, 'KTIK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.417, -80.151, 'KVUJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.43, -119.05, 'KBFL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.43, -81.94, 'KFQD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.44, -82.55, 'KAVL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.44, -94.8, 'KJSV');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (35.46, -77.96, 'KGWW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.4725, -98.0056, 'KRQO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.483, -81.167, 'KIPJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.4881, -97.8236, 'KRCE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.53, -108.78, 'KGUP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.533, -98.933, 'KCLK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.54, -97.65, 'KPWA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.541, -78.39, 'KJNX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.5448, -98.6685, 'KOJA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.57, -77.05, 'KOCW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.58, -79.1, 'KTTA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.598, -92.352, 'KCCA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.6, -91.2, 'KM19');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.61, -88.92, 'KMKL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.613, -100.996, 'KPPA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.62, -106.08, 'KSAF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.63, -77.4, 'KPGV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.65, -112.15, 'K40G');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.65, -79.9, 'KHBI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.65, -80.517, 'KRUQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.657, -109.061, 'KRQE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.66, -117.83, 'KIYK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.66, -105.15, 'KLVS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.66, -95.36, 'KMKO');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (35.67, -95.95, 'KOKM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.68, -121.28, 'K87Q');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.68, -120.63, 'KPRB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.69, -117.68, 'KNID');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.71, -101.4, 'KBGD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.72, -96.82, 'KCQB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.73, -91.65, 'KBVX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.76, -81.38, 'KHKY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.76, -80.96, 'KSVH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.783, -80.3, 'KEXX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.81, -83.98, 'KTYS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.82, -81.61, 'KMRN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.83, -90.65, 'KJBR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.85, -102.017, 'KDUX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.85, -97.42, 'KGOK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.86, -98.42, 'KJWG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.86, -77.88, 'KRWI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.88, -78.78, 'KRDU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.883, -106.283, 'KLAM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.8893, -101.03, 'KBPC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.895, -100.404, 'KHHF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.9, -82.817, 'KHSS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.92, -75.7, 'KMQI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.93, -95, 'KTQH');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (35.94, -89.83, 'KHKA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.94, -79.07, 'KIGX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.95, -96.767, 'KCUH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.96, -85.08, 'KCSV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.96, -112.15, 'KGCN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.967, -89.95, 'KBYH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (35.976, -115.133, 'KHND');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.01, -94.17, 'KFYV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.01, -79.95, 'KGSO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.01, -86.5, 'KMQY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.017, -75.667, 'KFFA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.02, -84.23, 'KOQT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.023, -78.33, 'KLHZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.03, -106.95, 'K4SL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.03, -102.55, 'KDHT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.03, -89.4, 'KDYR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.03, -76.57, 'KEDE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.04, -119.07, 'KPTV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.04, -95.98, 'KRVS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.05, -79.47, 'KBUY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.08, -115.15, 'KLAS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.12, -86.68, 'KBNA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.1255, -90.9216, 'KARG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.13, -80.22, 'KINT');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (36.16, -97.09, 'KSWO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.167, -83.4, 'KMRX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.19, -94.12, 'KASG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.19, -94.49, 'KSLG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.199, -81.651, 'KTNB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.2, -95.88, 'KTUL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.21, -115.2, 'KVGT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.22, -81.1, 'KUKF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.23, -115.03, 'KLSV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.26, -76.17, 'KECG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.28, -93.15, 'KHRO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.282, -94.307, 'KXNA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.285, -78.984, 'KTDF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.29, -92.59, 'KFLP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.29, -95.48, 'KGCM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.3, -77.17, 'KASJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.3, -99.77, 'KGAG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.3, -119.9, 'KNLC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.318, -119.629, 'KHJO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.3298, -77.6352, 'KIXA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.33, -119.4, 'KVIS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.333, -97.917, 'KEND');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.35, -94.22, 'KVBT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.36, -78.53, 'KHNZ');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (36.37, -92.47, 'KBPK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.38, -94.11, 'KROG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.39, -97.8, 'KWDG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.3989, -76.0161, 'K9W7');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.3989, -76.0161, 'KONX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.414, -100.75, 'KPYX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.42, -105.29, 'KAXX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.43, -81.42, 'KGEV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.44, -77.71, 'KRZZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.44, -99.52, 'KWWR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.46, -103.15, 'KCAO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.46, -80.55, 'KMWK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.46, -105.67, 'KSKX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.48, -82.4, 'KTRI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.5321, -93.2005, 'KBBG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.58, -79.33, 'KDAN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.583, -115.667, 'KINS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.59, -121.84, 'KMRY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.605, -94.738, 'KGMJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.611, -83.737, 'K1A6');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.62, -87.42, 'KCKV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.62, -116.02, 'KDRA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.63, -80.02, 'KMTV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.66, -76.32, 'KCPK');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (36.66, -121.61, 'KSNS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.669, -87.496, 'KHOP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.68, -76.6, 'KSFQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.68, -82.03, 'KVJI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.69, -78.05, 'KAVC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.69, -77.48, 'KEMV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.69, -101.51, 'KGUY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.7, -76.9, 'KFKN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.73, -97.1, 'KPNC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.74, -104.5, 'KRTN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.7451, -97.3496, 'KBKN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.76, -96.01, 'KBVO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.76, -108.23, 'KFMN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.77, -98.67, 'KAVK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.77, -80.82, 'KHLX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.77, -90.32, 'KPOF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.78, -119.72, 'KFAT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.83, -76.03, 'KNTU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.855, -84.856, 'KEKQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.88, -91.9, 'KUNO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.9, -81.35, 'KMKJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.9062, -94.0128, 'KHFJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.91, -106.57, 'KE33');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.91, -76.2, 'KORF');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (36.94, -76.28, 'KNGU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.94, -111.45, 'KPGA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.94, -121.79, 'KWVI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.96, -86.42, 'KBWG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.963, -85.946, 'KGLW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.98, -82.53, 'KLNP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.99, -77, 'KAKQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (36.99, -120.11, 'KMAE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.01, -101.88, 'KEHA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.05, -100.97, 'KLBL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.055, -84.614, 'KSME');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.064, -81.798, 'KJFZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.067, -89.217, 'KCIR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.07, -88.77, 'KPAH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.08, -95.57, 'KCFV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.09, -76.35, 'KLFI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.09, -84.04, 'KLOZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.09, -113.6, 'KSGU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.14, -76.62, 'KFAF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.14, -76.5, 'KPHF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.14, -80.68, 'KPSK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.16, -107.75, 'KDRO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.16, -97.03, 'KWLD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.18, -94.5, 'KJLN');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (37.183, -88.75, 'KM30');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.19, -77.52, 'KPTB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.208, -80.408, 'KBCB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.23, -89.58, 'KCGI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.23, -93.38, 'KSGF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.233, -76.717, 'KJGG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.24, -107.03, 'KPSO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.26, -104.33, 'KTAD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.28, -102.61, 'KSPD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.29, -120.52, 'KMCE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.3, -81.22, 'KBLF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.3, -108.63, 'KCEZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.3, -98.58, 'KP28');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.3, -95.5, 'KPPF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.33, -79.97, 'KROA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.34, -79.2, 'KLYH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.34, -121.82, 'KRHV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.35, -78.43, 'KFVX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.37, -118.37, 'KBIH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.37, -121.93, 'KSJC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.43, -122.05, 'KNUQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.46, -105.87, 'KALS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.464, -106.804, 'KCPW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.48, -122.12, 'KPAO');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (37.51, -77.31, 'KRIC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.512, -105.171, 'KVTP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.517, -76.767, 'KFYJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.53, -122.25, 'KSQL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.5779, -84.7697, 'KDVK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.6, -81.559, 'KI16');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.6, -83.32, 'KJKL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.617, -116.25, 'KBJN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.617, -97.267, 'KIAB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.617, -114.517, 'KP38');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.62, -109.47, 'K4BL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.62, -122.37, 'KSFO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.63, -120.95, 'KMOD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.64, -118.92, 'KMMH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.65, -75.77, 'KMFV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.66, -122.12, 'KHWD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.66, -97.43, 'KICT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.68, -95.48, 'KCNU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.7, -113.1, 'KCDC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.7, -121.82, 'KLVK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.7, -122.22, 'KOAK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.7, -77.43, 'KOFP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.702, -98.747, 'KPTT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.71, -112.16, 'KBCE');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (37.733, -92.15, 'KTBN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.75, -97.22, 'KAAO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.76, -90.43, 'KFAM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.76, -89, 'KMWA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.76, -87.17, 'KOWB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.78, -99.97, 'KDDC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.79, -81.12, 'KBKW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.79, -89.25, 'KMDH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.82, -87.69, 'KEHR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.82, -88.55, 'KHSB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.8596, -76.8941, 'KXSA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.88, -80.4, 'KLWB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.9, -85.967, 'KFTK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.91, -121.25, 'KSCK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.94, -100.72, 'KGCK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.94, -107.77, 'KTEX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.94, -75.47, 'KWAL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.96, -79.82, 'KHSP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (37.98, -122.05, 'KCCR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.011, -77.978, 'KLKU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.05, -87.53, 'KEVV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.05, -97.29, 'KEWK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.05, -84.6, 'KLEX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.05, -103.52, 'KLHX');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (38.07, -102.68, 'KLAA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.08, -97.87, 'KHUT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.08, -117.08, 'KTPH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.09, -88.123, 'KCUL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.1, -106.167, 'K04V');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.11, -92.55, 'KAIZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.14, -78.45, 'KCHO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.14, -91.77, 'KVIH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.1436, -122.556, 'KDVO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.1489, -76.42, 'KNUI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.15, -89.7, 'KSAR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.18, -84.9, 'KFFT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.19, -85.73, 'KSDF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.21, -122.28, 'KAPC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.23, -85.67, 'KLOU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.247, -78.046, 'KOMH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.26, -86.95, 'KHNB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.28, -78.85, 'KSHD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.28, -121.93, 'KSUU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.29, -76.4, 'KNHK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.29, -104.52, 'KPUB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.3, -95.717, 'KUKL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.308, -75.124, 'KOXB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.33, -88.87, 'KMVN');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (38.34, -96.2, 'KEMP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.34, -98.86, 'KGBD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.34, -75.5, 'KSBY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.378, -121.957, 'KVCB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.38, -110.72, 'K4HV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.38, -81.58, 'KCRW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.38, -88.42, 'KFWC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.38, -82.55, 'KHTS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.4, -77.45, 'KRMN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.43, -113.02, 'KMLF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.497, -106.32, 'KMYP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.51, -107.88, 'KMTJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.51, -77.3, 'KNYG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.51, -122.81, 'KSTS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.52, -89.08, 'KENL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.52, -121.5, 'KSAC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.53, -77.86, 'KCJR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.5393, -76.0304, 'KCGE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.55, -89.85, 'KBLV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.55, -106.92, 'KGUC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.55, -118.633, 'KHTH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.58, -90.15, 'KCPS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.58, -121.3, 'KMHR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.59, -92.16, 'KJEF');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (38.607, -87.727, 'KAJG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.65, -88.97, 'KSLO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.66, -90.63, 'KSUS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.667, -121.4, 'KMCC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.67, -88.45, 'KFOA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.69, -104.77, 'KFCS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.7, -75.36, 'KGED');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.7, -121.6, 'KSMF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.71, -93.16, 'KDMO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.72, -77.52, 'KHEF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.73, -77.18, 'KDAA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.73, -88.18, 'KOLY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.733, -80.65, 'K48I');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.733, -93.567, 'KSZL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.75, -109.75, 'KCNY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.76, -87.6, 'KLWV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.76, -90.37, 'KSTL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.784, -93.803, 'KRCM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.8, -106.217, 'K7BM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.8, -76.067, 'KESN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.8, -97.65, 'KSLN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.8142, -106.121, 'KAEJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.83, -76.87, 'KADW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.83, -104.72, 'KCOS');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (38.83, -92.22, 'KCOU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.83, -94.89, 'KIXD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.85, -94.74, 'KOJC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.86, -77.03, 'KDCA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.86, -99.27, 'KHYS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.87, -98.81, 'KRSL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.89, -79.85, 'KEKN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.91, -90.05, 'KALN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.91, -120, 'KTVL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.9144, -82.0983, 'K3I2');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.931, -90.433, 'KSET');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.955, -121.082, 'KAUN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.96, -95.67, 'KFOE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.96, -77.45, 'KIAD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.964, -94.374, 'KLXT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.98, -104.82, 'KAFF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.98, -76.48, 'KNAK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (38.983, -79.133, 'KW99');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39, -80.267, 'KW22');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.01, -110.15, 'KU28');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.01, -74.9, 'KWWD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.016, -87.65, 'KRSV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.02, -95.22, 'KLWC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.05, -105.514, 'K4BM');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (39.05, -84.67, 'KCVG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.05, -96.767, 'KFRI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.07, -88.53, 'K1H2');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.08, -77.57, 'KJYO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.08, -95.62, 'KTOP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.083, -76.767, 'KFME');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.1, -84.42, 'KLUK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.11, -121.57, 'KMYV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.12, -108.53, 'KGJT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.12, -94.6, 'KMKC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.14, -121.44, 'KBAB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.14, -86.62, 'KBMG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.14, -75.47, 'KDOV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.14, -123.2, 'KUKI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.15, -78.15, 'KOKV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.16, -96.67, 'KMHK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.163, -89.675, 'K3LF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.1683, -77.166, 'KGAI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.19, -76.67, 'KBWI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.219, -104.641, 'KMNH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.22, -106.87, 'KASE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.22, -106.32, 'KLXV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.24, -102.29, 'KITR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.26, -85.88, 'KBAK');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (39.26, -103.66, 'KLIC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.28, -76.61, 'KDMH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.29, -120.7, 'KBLU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.29, -80.23, 'KCKB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.29, -114.85, 'KELY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.3, -94.73, 'KMCI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.33, -120.13, 'KTRK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.34, -76.42, 'KMTN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.34, -112.59, 'KU24');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.36, -77, 'KDMW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.36, -84.52, 'KHAO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.36, -81.43, 'KPKB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.38, -101.7, 'KGLD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.38, -75.07, 'KMIV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.39, -99.83, 'KHLC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.41, -77.98, 'KMRB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.417, -107.367, 'K5SM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.418, -77.374, 'KFDK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.43, -83.8, 'KILN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.43, -118.7, 'KNFL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.46, -74.57, 'KACY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.46, -87.3, 'KHUF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.47, -76.17, 'KAPG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.475, -106.153, 'KCCU');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (39.48, -88.28, 'KMTO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.49, -121.62, 'KOVE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.5, -117.083, 'KU31');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.51, -115.97, 'KP68');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.51, -119.78, 'KRNO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.53, -89.33, 'KTAZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.54, -107.72, 'KRIL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.55, -97.65, 'KCNK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.57, -104.85, 'KAPA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.59, -84.22, 'KMGY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.596, -85.8, 'KGEZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.617, -78.767, 'KCBE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.62, -110.75, 'KPUC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.63, -90.78, 'KPPQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.64, -79.92, 'KMGW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.66, -106.92, 'KEGE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.68, -75.6, 'KILG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.7, -87.67, 'KPRG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.702, -104.75, 'KBKF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.71, -77.73, 'KHGR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.73, -86.27, 'KIND');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.75, -82.67, 'KLHQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.77, -94.91, 'KSTJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.78, -90.23, 'KIJX');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (39.785, -104.543, 'KFTG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.79, -121.85, 'KCIC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.82, -93.58, 'KCDJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.825, -86.296, 'KEYE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.83, -82.93, 'KLCK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.833, -83.833, 'KSGH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.84, -88.87, 'KDEC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.84, -84.05, 'KFFO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.86, -89.67, 'KSPI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.87, -104.67, 'KDEN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.87, -75.23, 'KPHL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.9, -83.13, 'KTZR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.91, -105.12, 'KBJC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.91, -84.2, 'KDAY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.92, -76.87, 'KTHV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.9275, -74.2924, 'KMJX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.94, -91.2, 'KUIN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.95, -74.84, 'KVAY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (39.96, -81.9, 'KZZV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.01, -82.88, 'KCMH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.02, -74.6, 'KWRI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.023, -82.462, 'KVTA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.0306, -86.2514, 'KTYQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.04, -88.28, 'KCMI');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (40.04, -107.89, 'KEEO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.04, -74.32, 'KNEL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.04, -124.07, 'KO87');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.05, -106.36, 'K20V');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.0503, -105.584, 'KCRV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.08, -95.58, 'KFNB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.08, -118.55, 'KLOL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.09, -83.07, 'KOSU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.09, -75.02, 'KPNE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.11, -92.55, 'KIRK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.12, -85.62, 'KAID');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.12, -76.3, 'KLNS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.138, -75.265, 'KLOM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.14, -80.29, 'KAFJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.15, -122.25, 'KRBL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.152, -97.587, 'KHJH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.16, -89.33, 'KAAA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.17, -103.22, 'KAKO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.17, -80.65, 'KHLG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.18, -74.13, 'KBLM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.19, -75.13, 'KNXX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.2, -87.6, 'KDNV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.21, -112.93, 'KDPG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.21, -76.77, 'KMDT');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (40.23, -76.85, 'KCXY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.23, -100.58, 'KMCK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.23, -111.72, 'KPVU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.24, -75.56, 'KPTW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.242, -85.396, 'KMIE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.267, -106.45, 'K3MW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.29, -79.4, 'KLBE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.29, -88.14, 'KTIP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.29, -74.82, 'KTTN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.3, -78.32, 'KAOO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.3, -96.75, 'KBIE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.317, -112.3, 'KT62');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.33, -75.12, 'KDYL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.33, -78.83, 'KJST');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.36, -79.94, 'KAGC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.39, -75.97, 'KRDG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.43, -104.63, 'KGXY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.43, -86.93, 'KLAF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.435, -75.382, 'KUKT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.44, -76.57, 'KMUI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.44, -109.51, 'KVEL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.45, -99.33, 'KHDE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.46, -105.01, 'KFNL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.47, -91.43, 'KEOK');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (40.47, -81.42, 'KPHD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.48, -88.93, 'KBMI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.48, -106.82, 'KSBS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.51, -107.53, 'KCAG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.51, -107.25, 'KHDN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.51, -80.22, 'KPIT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.51, -122.3, 'KRDD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.52, -90.65, 'KMQB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.53, -86.06, 'KOKK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.54, -101.63, 'KIML');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.6, -95.87, 'KAFK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.6069, -95.8644, 'KFAK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.61, -116.87, 'KB23');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.61, -98.43, 'KHSI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.62, -83.06, 'KMNN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.624, -74.669, 'KSMQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.63, -79.1, 'KIDI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.631, -93.901, 'KLWD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.65, -86.15, 'KGUS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.66, -75.43, 'KABE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.66, -73.78, 'KJFK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.66, -89.68, 'KPIA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.67, -91.33, 'KFSW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.6839, -92.901, 'KTVK');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (40.71, -84.03, 'KAOH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.71, -74.17, 'KEWR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.72, -95.03, 'KICL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.73, -99, 'KEAR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.73, -114.03, 'KENV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.73, -73.41, 'KFRG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.75, -95.42, 'KSDA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.76, -80.33, 'KBVI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.78, -73.88, 'KLGA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.78, -99.77, 'KLXN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.783, -73.967, 'KNYC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.79, -91.12, 'KBRL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.79, -79.95, 'KBTP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.79, -111.97, 'KSLC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.8, -124.167, 'KEKA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.8, -73.1, 'KISP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.8, -74.42, 'KMMU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.817, -72.867, 'KHWV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.82, -76.86, 'KSEG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.83, -82.52, 'KMFD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.84, -115.78, 'KEKO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.84, -72.63, 'KFOK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.86, -96.75, 'KLNK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.86, -74.05, 'KTEB');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (40.86, -77.83, 'KUNV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.867, -100, 'KCZD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.87, -81.89, 'KBJJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.88, -98, 'KAUH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.88, -74.28, 'KCDW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.883, -121.667, 'KBNY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.9, -97.62, 'KJYR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.91, -117.8, 'KWMC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.92, -88.63, 'KPNT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.93, -81.43, 'KCAK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.94, -90.43, 'KGBG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.9484, -95.9174, 'KPMV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.95, -91.51, 'KMPZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.98, -124.1, 'KACV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.98, -98.32, 'KGRI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (40.98, -72.25, 'KHTO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.01, -74.74, 'K12N');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.01, -85.2, 'KFWA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.02, -89.39, 'KC75');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.02, -94.37, 'KCSQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.02, -95.27, 'KRDK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.0254, -80.4134, 'KUCP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.03, -93.37, 'KCNC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.03, -83.67, 'KFDY');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (41.033, -81.467, 'KAKR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.033, -105.45, 'KPUM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.047, -78.412, 'KFIG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.05, -91.98, 'KFFL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.05, -101.8, 'KOGA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.07, -87.85, 'KIKK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.08, -73.72, 'KHPN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.08, -71.92, 'KMTP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.11, -92.45, 'KOTM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.11, -102.98, 'KSNY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.117, -95.917, 'KOFF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.12, -111.97, 'KHIF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.13, -106.57, 'KSKL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.14, -100.68, 'KLBF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.14, -75.38, 'KMPO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.15, -105.4, 'KVDW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.16, -114.97, 'K9BB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.16, -104.82, 'KCYS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.18, -73.13, 'KBDR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.18, -71.58, 'KBID');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.188, -103.677, 'KIBM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.19, -78.9, 'KDUJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.196, -96.112, 'KMLE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.2, -112.01, 'KOGD');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (41.21, -74.63, 'KFWN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.233, -92.483, 'KOOA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.26, -70.07, 'KACK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.26, -76.92, 'KIPT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.27, -95.77, 'KCBF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.27, -111.03, 'KEVW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.27, -80.67, 'KYNG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.275, -85.84, 'KASW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.28, -91.67, 'KAWG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.28, -72.88, 'KHVN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.29, -110.77, 'KFIR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.3, -95.9, 'KOMA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.3, -93.12, 'KOXV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.33, -75.73, 'KAVP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.33, -72.05, 'KGON');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.33, -105.68, 'KLAR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.33, -122.32, 'KMHS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.33, -86.664, 'KOXI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.34, -84.43, 'KDFI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.346, -82.179, 'KLPR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.35, -89.15, 'KVYS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.35, -71.8, 'KWST');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.37, -73.48, 'KDXR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.37, -91.15, 'KMUT');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (41.3839, -72.5058, 'KSNC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.39, -79.87, 'KFKL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.4, -95.05, 'KAIO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.4, -84.99, 'KGWB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.4, -92.95, 'KPEA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.4, -104.867, 'KWTR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.41, -70.62, 'KMVY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.41, -73.1, 'KOXC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.4148, -96.109, 'KBTA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.4181, -96.1136, 'KK46');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.42, -81.85, 'KCLE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.43, -88.42, 'KC09');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.44, -99.66, 'KBBW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.45, -96.53, 'KFET');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.45, -87.01, 'KVPZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.46, -90.52, 'KMLI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.46, -97.35, 'KOLU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.491, -120.564, 'KAAT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.51, -74.26, 'KMGJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.51, -72.83, 'KMMK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.51, -74.1, 'KSWF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.52, -81.68, 'KBKL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.52, -88.18, 'KJOT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.53, -109.46, 'KCMS');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (41.53, -85.79, 'KGSH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.53, -87.53, 'KIGQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.54, -93.65, 'KDSM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.54, -71.28, 'KUUU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.56, -83.48, 'KTDZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.58, -81.48, 'KCGF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.583, -106.2, 'KARL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.584, -95.34, 'KHNR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.61, -88.1, 'KLOT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.61, -71.42, 'KOQU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.61, -109.07, 'KRKS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.61, -83.8, 'KTOL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.62, -90.58, 'KDVN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.62, -80.21, 'KGKJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.62, -87.42, 'KGYY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.62, -98.95, 'KODX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.633, -91.543, 'KIOW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.64, -108.58, 'KBIT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.64, -73.88, 'KPOU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.66, -70.52, 'KFMH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.667, -69.967, 'KCHH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.67, -115.79, 'KAWH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.68, -70.28, 'KHYA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.68, -93.02, 'KTNU');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (41.69, -70.97, 'KEWB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.69, -93.57, 'KIKV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.7, -94.92, 'KADU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.7, -69.99, 'KCQX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.7092, -92.7349, 'KGGI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.71, -107.78, 'KCTD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.71, -74.8, 'KMSV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.71, -86.32, 'KSBN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.71, -96.1, 'KTQE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.73, -83.65, 'KDUH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.73, -86, 'KEKM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.73, -72.65, 'KHFD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.73, -71.43, 'KPVD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.733, -98.05, 'KBVN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.75, -72.18, 'KIJD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.75, -89.67, 'KSQI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.77, -88.47, 'KARR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.779, -80.697, 'KHZY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.79, -124.24, 'KCEC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.79, -111.85, 'KLGU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.79, -87.75, 'KMDW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.79, -122.47, 'KSIY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.8, -78.64, 'KBFD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.8, -107.2, 'KRWL');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (41.81, -85.44, 'KIRS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.828, -94.1598, 'KPRO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.84, -90.34, 'KCWI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.87, -84.07, 'KADG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.88, -103.6, 'KBFF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.89, -91.7, 'KCID');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.89, -89.08, 'KRPJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.89, -71.02, 'KTAN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.91, -70.73, 'KPYM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.91, -71.4, 'KSFZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.921, -84.586, 'KJYM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.93, -88.72, 'KDKB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.93, -88.25, 'KDPA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.93, -85.05, 'KOEB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.933, -104.55, 'KBRX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.94, -72.68, 'KBDL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.94, -83.43, 'KTTF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.95, -116.1, 'KOWY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.959, -85.59, 'KHAI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.962, -100.569, 'KTIF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.98, -95.38, 'KDNS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.98, -97.43, 'KOFK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.98, -87.9, 'KORD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (41.99, -93.62, 'KAMW');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (42.01, -70.2, 'KPVC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.05, -124.283, 'K4BK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.05, -102.8, 'KAIA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.05, -93.85, 'KBNW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.05, -94.78, 'KCIN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.05, -101.067, 'KMHN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.05, -90.1, 'KSFY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.06, -104.15, 'KTOR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.08, -80.18, 'KERI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.083, -124.283, 'KBOK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.1, -77.983, 'KELZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.1, -83.16, 'KONZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.11, -92.91, 'KMIW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.11, -87.9, 'KPWK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.14, -86.44, 'KBEH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.16, -72.72, 'KBAF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.16, -79.25, 'KJHW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.16, -121.73, 'KLMT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.18, -76.9, 'KELM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.18, -112.32, 'KMLD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.19, -120.35, 'KLKV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.19, -71.17, 'KOWD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.21, -72.53, 'KCEF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.21, -71.11, 'KMQE');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (42.21, -89.1, 'KRFD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.219, -92.026, 'KVTI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.22, -83.75, 'KARB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.23, -75.98, 'KBGM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.23, -83.33, 'KDTW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.23, -91.17, 'KMXO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.23, -83.53, 'KYIP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.24, -85.55, 'KAZO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.24, -84.96, 'KRMY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.242, -96.981, 'KLCG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.25, -89.58, 'KFEP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.27, -84.47, 'KJXN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.28, -71.87, 'KORH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.3, -113.37, 'K77M');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.3, -85.25, 'KBTL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.351, -86.256, 'KLWA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.38, -71.03, 'KBOS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.38, -122.87, 'KMFR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.4, -83.017, 'KDET');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.41, -90.7, 'KDBQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.41, -96.38, 'KSUX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.42, -87.87, 'KUGN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.43, -93.87, 'KEBS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.43, -73.29, 'KPSF');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (42.433, -105.033, 'KSIB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.454, -91.948, 'KIIB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.47, -71.29, 'KBED');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.4708, -93.27, 'KIFA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.48, -76.47, 'KITH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.48, -98.68, 'KONL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.48, -114.48, 'KTWF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.5, -79.28, 'KDKK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.54, -113.77, 'KBYI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.543, -83.178, 'KVLL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.55, -83.183, 'K7D2');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.55, -92.4, 'KALO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.55, -71.76, 'KFIT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.55, -94.18, 'KFOD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.56, -106.85, 'KPAT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.567, -77.717, 'KDSV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.57, -84.81, 'KFPK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.57, -84.42, 'KTEW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.58, -110.1, 'KBPI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.58, -108.28, 'KBVR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.58, -72.28, 'KORE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.58, -117.89, 'KREO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.59, -99.99, 'KANW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.59, -70.92, 'KBVY');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (42.59, -87.94, 'KENW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.6, -95.23, 'KSLB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.61, -89.59, 'KEFT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.62, -89.03, 'KJVL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.62, -82.84, 'KMTC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.62, -123.37, 'KSXT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.63, -83.98, 'KOZW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.65, -77.05, 'KPEO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.66, -111.58, 'KU78');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.67, -83.42, 'KPTK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.68, -91.96, 'KOLZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.6894, -90.4444, 'KPVB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.691, -88.305, 'KBUU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.71, -73.17, 'KAQW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.728, -114.453, 'KJER');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.73, -71.12, 'KLWM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.732, -95.556, 'KCKP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.75, -86.1, 'KBIV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.75, -93.77, 'KCAV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.76, -73.8, 'KALB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.76, -87.81, 'KRAC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.78, -84.6, 'KLAN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.78, -96.2, 'KLRJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.783, -109.8, 'KPNA');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (42.79, -71.52, 'KASH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.8, -72, 'KAFN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.8, -105.39, 'KDGW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.83, -105.86, 'KDRC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.83, -108.73, 'KLND');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.833, -124.567, 'K92S');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.84, -103.08, 'KCDR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.86, -73.93, 'KSCH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.86, -100.55, 'KVTN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.89, -73.246, 'KDDH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.89, -85.52, 'KGRR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.89, -90.23, 'KMRJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.91, -72.27, 'KEEN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.92, -82.53, 'KPHN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.92, -97.38, 'KYKN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.93, -106.47, 'KCPR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.93, -112.6, 'KPIH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.938, -85.0606, 'KY70');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.94, -78.73, 'KBUF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.94, -71.43, 'KMHT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.96, -87.9, 'KMKE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.98, -83.73, 'KFNT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.98, -96.07, 'KORC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (42.993, -84.139, 'KRNP');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (43.01, -102.51, 'KIEN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.01, -88.2, 'KUES');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.02, -91.12, 'KPDC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.05, -115.87, 'KMUO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.05, -108.45, 'KRIW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.07, -92.62, 'KCCY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.08, -94.27, 'KAXA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.09, -107.32, 'KHLD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.09, -70.82, 'KPSM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.11, -78.95, 'KIAG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.1143, -89.5315, 'KC29');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.12, -88.05, 'KMWC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.12, -77.67, 'KROC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.12, -76.12, 'KSYR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.12, -106.33, 'KTMH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.14, -89.33, 'KMSN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.16, -93.33, 'KMCW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.16, -90.68, 'KOVS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.16, -75.38, 'KUCA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.17, -88.72, 'KRYV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.17, -95.21, 'KSPW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.18, -86.27, 'KMKG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.21, -71.5, 'KCON');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.21, -90.18, 'KLNR');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (43.22, -95.83, 'KSHL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.23, -123.35, 'KRBG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.234, -75.407, 'KRME');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.278, -70.92, 'KDAW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.28, -91.73, 'KDEH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.32, -84.69, 'KAMN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.34, -72.52, 'KVSF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.36, -76.39, 'KFZY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.36, -73.62, 'KGFL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.38, -99.85, 'KICR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.4, -94.75, 'KEST');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.4, -70.7, 'KSFM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.43, -124.25, 'KOTH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.43, -88.7, 'KUNU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.433, -83.862, 'KHYX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.44, -88.13, 'KETB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.45, -83.45, 'K78D');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.459, -83.445, 'KCFS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.51, -114.3, 'KSUN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.522, -89.771, 'KDLL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.53, -112.07, 'KIDA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.53, -84.08, 'KMBS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.54, -72.95, 'KRUT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.5794, -90.8965, 'KY51');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (43.58, -118.95, 'KBNO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.58, -116.22, 'KBOI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.58, -71.43, 'KLCI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.59, -96.74, 'KFSD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.61, -110.73, 'KJAC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.62, -84.74, 'KMOP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.621, -96.216, 'KLYV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.63, -72.3, 'KLEB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.64, -116.64, 'KEUL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.65, -70.301, 'KPWM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.66, -94.42, 'KFRM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.66, -94.99, 'KMJQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.66, -95.58, 'KOTG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.6629, -84.2613, 'KIKW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.67, -92.94, 'KAUM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.677, -92.18, 'KFKA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.69, -93.37, 'KAEL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.72, -85.5, 'KRQB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.733, -103.618, 'KCUT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.7417, -111.098, 'KDIJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.77, -88.49, 'KFLD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.77, -98.04, 'KMHE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.78, -71.53, 'K1P1');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.78, -87.85, 'KSBM');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (43.79, -82.99, 'KBAX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.8, -99.32, 'K9V9');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.83, -111.81, 'KRXE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.88, -91.25, 'KLSE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.883, -70.25, 'KGYX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.89, -69.93, 'KNHZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.91, -95.11, 'KMWM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.93, -105.44, 'KBFU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.93, -92.5, 'KRST');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.933, -90.267, 'KVOK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.94, -106.64, 'KIDV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.95, -69.7, 'KIWI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.958, -90.738, 'KCMY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.96, -86.41, 'KLDM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.98, -70.95, 'KIZG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.98, -107.97, 'KWRL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.987, -95.783, 'KDVP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.99, -94.56, 'KJYG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (43.99, -96.32, 'KPQN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.01, -76.02, 'KART');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.01, -88.57, 'KOSH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.018, -92.831, 'KTOB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.02, -117.01, 'KONO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.022, -82.793, 'KP58');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (44.0416, -89.3045, 'KY50');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.05, -75.74, 'KGTB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.05, -70.29, 'KLEW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.05, -101.6, 'KPHP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.05, -103.07, 'KRAP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.07, -93.55, 'KACQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.08, -69.12, 'KRKD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.09, -91.7, 'KONA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.12, -123.22, 'KEUG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.12, -93.25, 'KOWA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.14, -87.67, 'KMTW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.15, -103.1, 'KRCA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.17, -114.93, 'KSNT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.21, -106.1, 'KDHS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.21, -72.57, 'KMPV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.23, -93.92, 'KMKT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.249, -95.607, 'KTKC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.26, -88.52, 'KATW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.27, -108.87, 'KMTR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.28, -86.25, 'KMBL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.28, -71.3, 'KMWN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.28, -121.15, 'KRDM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.29, -85.42, 'KCAD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.29, -104.62, 'KIKA');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (44.3, -96.8, 'KBKX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.3, -112.1, 'KS14');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.32, -69.8, 'KAUG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.32, -94.5, 'KULM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.333, -89.02, 'KPCZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.34, -93.31, 'KFBL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.36, -105.53, 'KGCC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.36, -71.53, 'KHIE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.36, -89.83, 'KISW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.38, -106.72, 'KBYG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.38, -84.68, 'KHTL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.39, -98.22, 'KHON');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.39, -100.28, 'KPIR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.39, -74.2, 'KSLK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.4029, -118.968, 'KGCD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.42, -72.02, 'K1V4');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.42, -118.95, 'K5J0');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.46, -68.37, 'KBHB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.46, -95.82, 'KMML');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.46, -83.4, 'KOSC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.467, -93.017, 'KSYN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.48, -73.15, 'KBTV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.48, -88.13, 'KGRB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.4803, -103.783, 'KSPF');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (44.51, -123.29, 'KCVO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.52, -108.08, 'KGEY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.523, -114.215, 'KLLJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.53, -109.02, 'KCOD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.53, -72.61, 'KMVL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.53, -106.81, 'KPIN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.54, -72.03, 'K6B8');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.54, -69.69, 'KWVL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.55, -110.42, 'KP60');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.55, -95.08, 'KRWF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.55, -89.53, 'KSTE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.58, -124.05, 'KONP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.583, -124.067, 'KJNW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.59, -71.18, 'KBML');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.59, -92.49, 'KRGK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.61, -88.73, 'KCLI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.617, -86.2, 'KFKS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.63, -90.18, 'KMFI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.64, -93.24, 'KLVN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.6509, -73.4681, 'KPBG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.66, -111.1, 'KWEY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.68, -84.72, 'KGOV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.683, -111.117, 'KWYS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.71, -103.8, 'KEFC');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (44.72, -96.26, 'KCNB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.73, -85.58, 'KTVC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.7533, -95.556, 'KGDB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.757, -94.082, 'KGYL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.78, -95.03, 'KOVL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.78, -106.97, 'KSHR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.7873, -88.56, 'KEZS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.79, -89.67, 'KCWA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.81, -68.83, 'KBGR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.84, -117.82, 'KBKE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.84, -93.47, 'KFCM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.84, -87.37, 'KSUE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.85, -93.15, 'KSGS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.87, -94.39, 'KHCD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.88, -91.48, 'KEAU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.883, -91.867, 'KLUM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.89, -93.22, 'KMSP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.89, -116.1, 'KMYL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.92, -97.16, 'KATY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.93, -89.62, 'KAUW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.93, -123.02, 'KSLE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.94, -74.85, 'KMSS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.94, -93.05, 'KSTP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.95, -68.667, 'KOLD');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (44.96, -72.23, 'KEFK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.97, -95.72, 'KMVE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.99, -85.2, 'KACB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.99, -96.18, 'KDXX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (44.9975, -92.8557, 'K21D');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.01, -89.13, 'KAIG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.024, -84.678, 'KGLR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.04, -102.02, 'KD07');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.08, -83.57, 'KAPN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.08, -93.38, 'KMIC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.1, -90.3, 'KMDZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.11, -95.09, 'KILL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.12, -95.13, 'KBDH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.12, -87.63, 'KMNM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.12, -113.88, 'KSMN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.14, -94.52, 'KLJF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.148, -92.538, 'KRNH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.159, -93.843, 'KCFE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.16, -93.22, 'KANE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.19, -123.14, 'KMMV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.2, -89.71, 'KRRL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.23, -96, 'KAQP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.236, -93.986, 'KMGG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.25, -122.77, 'KUAO');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (45.26, -112.55, 'KDLN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.283, -118, 'KLGD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.3, -85.27, 'KCVX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.31, -92.69, 'KOEO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.31, -96.42, 'KVVV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.32, -95.65, 'KBBB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.3722, -94.7464, 'KPEX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.4, -83.817, 'KPZQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.41, -90.24, 'KPBH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.417, -123.817, 'KS47');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.42, -84.91, 'KMGN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.46, -98.43, 'KABR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.462, -69.595, 'KGNR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.469, -89.806, 'KTKV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.483, -91, 'KRCX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.51, -118.4, 'KMEH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.51, -91.73, 'KRPD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.54, -122.95, 'KHIO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.55, -100.41, 'KMBG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.55, -94.07, 'KSTC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.55, -122.4, 'KTTD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.56, -93.61, 'KPNM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.57, -103.53, 'K2WX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.57, -93.27, 'KCBG');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (45.57, -95.97, 'KMOX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.58, -122.6, 'KPDX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.58, -84.8, 'KPLN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.62, -121.15, 'KDLS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.62, -122.66, 'KVUO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.63, -89.47, 'KRHI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.65, -95.32, 'KGHW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.65, -68.7, 'KMLT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.65, -84.52, 'KSLH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.65, -84.467, 'KY15');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.67, -97, 'K8D3');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.69, -121.88, 'KCZK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.69, -118.85, 'KPDT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.698, -92.953, 'KROS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.7, -85.57, 'KSJX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.7066, -94.9334, 'KD39');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.71, -96.5, 'KETH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.71, -110.43, 'KLVM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.73, -87.08, 'KESC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.769, -122.862, 'KSPB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.79, -111.15, 'KBZN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.8, -108.53, 'KBIL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.81, -88.11, 'KIMT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.823, -92.373, 'KRZN');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (45.826, -119.261, 'KHRI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.86, -84.64, 'KMCD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.87, -95.41, 'KAXN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.89, -93.27, 'KJMR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.8983, -94.8739, 'K14Y');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.93, -89.73, 'KARV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.93, -89.27, 'KEGV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.93, -85.92, 'KP75');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.96, -112.5, 'KBTM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.96, -94.35, 'KLXL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.97, -86.17, 'KISQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (45.9861, -95.992, 'KY63');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46, -102.65, 'KHEI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.0229, -92.8952, 'K04W');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.09, -118.29, 'KALW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.117, -122.9, 'KKLS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.14, -67.78, 'KHUL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.15, -89.217, 'KLNL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.15, -115.6, 'KP69');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.16, -123.88, 'KAST');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.16, -91.45, 'KHYR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.1869, -103.428, 'KBPP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.233, -96.6, 'KBWP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.26, -84.47, 'KCIU');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (46.27, -119.12, 'KPSC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.3, -96.07, 'KFFM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.31, -85.46, 'KERY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.333, -104.25, 'KBHK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.354, -87.394, 'KSAW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.38, -94.81, 'KSAZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.39, -117.02, 'KLWS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.4, -94.13, 'KBRD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.4, -86.65, 'KP53');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.417, -92.8, 'KMZH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.44, -109.84, 'K3HT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.44, -105.87, 'KMLS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.447, -95.212, 'KADC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.48, -122.8, 'KTDO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.485, -84.366, 'KANJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.533, -87.55, 'KMQT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.54, -90.13, 'KIWD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.55, -93.69, 'KAIT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.55, -90.92, 'KASX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.56, -120.53, 'KYKM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.58, -119.58, 'KHMS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.61, -112, 'KHLN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.617, -69.533, 'K40B');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.617, -93.317, 'KHZX');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (46.68, -113.15, 'K3DU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.69, -68.05, 'KPQI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.69, -92.095, 'KSUW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.71, -92.5, 'KCOQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.72, -92.04, 'KDYT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.72, -94.38, 'KPWC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.76, -117.12, 'KPUW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.78, -100.75, 'KBIS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.79, -102.8, 'KDIK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.83, -95.88, 'KDTL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.84, -92.18, 'KDLH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.84, -96.66, 'KJKJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.88, -68.02, 'KCAR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.91, -96.8, 'KFAR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.91, -95.07, 'KPKD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.92, -114.1, 'KMSO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.93, -98.68, 'KJMS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.98, -123.97, 'KHQM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.98, -122.9, 'KOLM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (46.992, -94.2, 'KXVG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.03, -120.53, 'KELN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.05, -109.45, 'KLWT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.05, -91.75, 'KTWM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.09, -122.58, 'KGRF');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (47.14, -104.8, 'KGDV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.16, -122.48, 'KTCM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.18, -88.5, 'KCMX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.21, -91.41, 'KBFW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.21, -119.32, 'KMWH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.23, -93.52, 'KGPZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.23, -123.15, 'KSHN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.28, -122.58, 'KTIW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.29, -68.32, 'KFVE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.29, -121.33, 'KSMP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.33, -119.52, 'KEPH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.33, -106.93, 'KJDN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.39, -92.85, 'KHIB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.41, -120.2, 'KEAT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.41, -92.5, 'KEVM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.44, -122.31, 'KSEA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.45, -115.67, 'KMLP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.45, -87.9, 'KP59');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.47, -111.38, 'KGTF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.48, -122.77, 'KPWT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.51, -94.93, 'KBJI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.51, -122.22, 'KRNT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.517, -111.183, 'KGFA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.54, -122.3, 'KBFI');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (47.593, -95.773, 'KFSE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.6, -115.367, 'K3TH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.61, -101.4, 'KN60');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.62, -117.53, 'KGEG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.62, -117.65, 'KSKA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.68, -117.32, 'KSFF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.73, -104.18, 'KSDY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.75, -90.34, 'KGNA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.78, -116.82, 'KCOE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.78, -93.65, 'KFOZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.82, -92.69, 'KCQM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.84, -90.38, 'KCKC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.86, -96.62, 'KCKN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.91, -91.82, 'KELO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.91, -122.28, 'KPAE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.933, -97.383, 'KRDR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.96, -97.18, 'KGFK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.96, -124.55, 'KUIL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (47.974, -117.428, 'KDEW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.02, -92.87, 'KORB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.08, -96.18, 'KTVF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.09, -105.58, 'KOLF');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.12, -123.5, 'KCLM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.12, -98.9, 'KDVL');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (48.15, -94.52, 'KVWU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.16, -103.6, 'KISN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.17, -122.17, 'KAWO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.21, -106.63, 'KGGW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.25, -122.667, 'K76S');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.27, -92.57, 'KCDD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.28, -101.28, 'KMOT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.3, -114.27, 'KFCA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.3, -116.55, 'KSZT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.3042, -114.264, 'KGPI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.36, -122.65, 'KNUW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.417, -101.35, 'KMIB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.46, -119.52, 'KOMK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.467, -122.417, 'KBVS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.52, -123.02, 'KFHR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.55, -117.89, 'KCQV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.55, -109.77, 'KHVR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.58, -93.38, 'KINL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.61, -112.37, 'KCTB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.717, -122.917, 'KORS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.73, -94.6, 'KBDE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.79, -122.54, 'KBLI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.79, -96.95, 'KHCO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.86, -95.69, 'KROX');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (48.9333, -95.3333, 'KRAD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (48.94, -95.35, 'KRRT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (49.32, -94.88, 'KFGN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (51.89, -176.65, 'PADK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (52.217, -174.2, 'PAAK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (52.72, 174.12, 'PASY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (53.89, -166.53, 'PADU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (55.04, -131.57, 'PANT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (55.08, -131.35, 'PAMM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (55.1163, -162.266, 'PAVC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (55.21, -162.72, 'PACD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (55.21, -132.84, 'PAHY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (55.32, -160.52, 'PASD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (55.35, -131.7, 'PAKT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (55.59, -133.09, 'PAKW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (56.0075, -161.16, 'PAOU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (56.26, -134.66, 'PAAP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (56.31, -158.37, 'PAJC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (56.35, -169.4, 'PAPB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (56.48, -132.37, 'PAWG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (56.82, -132.97, 'PAPG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (56.96, -158.62, 'PAPH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (56.97, -133.95, 'PAFE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (57.07, -135.35, 'PASI');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (57.15, -170.22, 'PASN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (57.5036, -134.585, 'PAGN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (57.5804, -157.572, 'PAPN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (57.76, -152.5, 'PADQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (58.12, -135.45, 'PAOH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (58.21, -136.35, 'PAEL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (58.38, -134.58, 'PAJN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (58.42, -135.73, 'PAGS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (58.42, -157.37, 'PAII');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (58.66, -162.07, 'PAEH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (58.68, -156.65, 'PAKN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (58.9902, -159.05, 'PAMB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.0114, -161.82, 'PAPM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.05, -158.52, 'PADL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.05, -160.41, 'PATG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.25, -135.52, 'PAHN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.324, -155.902, 'PAIG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.44, -146.33, 'PAMD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.44, -151.7, 'PASO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.48, -135.32, 'PAGY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.52, -139.67, 'PAYA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.64, -151.5, 'PAHO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (59.76, -154.92, 'PAIL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (60.12, -149.45, 'PAWD');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (60.21, -154.31, 'PALJ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (60.37, -166.27, 'PAMY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (60.48, -151.03, 'PASX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (60.5, -145.5, 'PACV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (60.5414, -165.087, 'PAOO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (60.58, -151.25, 'PAEN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (60.77, -148.69, 'PAWR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (60.78, -161.8, 'PABE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (60.783, -148.833, 'PATO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (60.82, -152.31, 'PALV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.1, -155.567, 'PASV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.13, -146.25, 'PAVD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.13, -146.35, 'PAVW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.17, -150, 'PANC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.19, -149.97, 'PALH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.214, -149.846, 'PAMR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.25, -149.8, 'PAED');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.25, -153.817, 'PAER');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.42, -149.52, 'PABV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.44, -142.94, 'PAMX');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.5363, -160.341, 'PALG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.54, -166.16, 'PAHP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.58, -159.53, 'PANI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.58, -149.45, 'PAWS');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (61.61, -149.09, 'PAAQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.72, -148.89, 'PAJV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.72, -157.15, 'PASL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.76, -150.06, 'PAUO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.7749, -161.319, 'PARS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.783, -166.033, 'PACZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.82, -147.5, 'PASP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.8453, -165.571, 'PACM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.8643, -162.026, 'PADM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.93, -147.17, 'PAZK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.97, -151.18, 'PASW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (61.99, -152.09, 'PAHZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.03, -146.68, 'PALK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.07, -163.3, 'PASM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.0954, -163.682, 'PAMO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.1, -152.75, 'PAPT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.15, -145.45, 'PAGK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.1883, -159.775, 'PAHC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.3, -150.1, 'PATK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.41, -143, 'PABN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.54, -153.62, 'PAFK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.65, -160.18, 'PANV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.71, -143.99, 'PADT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.77, -164.5, 'PAEM');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (62.89, -149.84, 'PAEC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.8944, -155.977, 'PATL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.95, -155.61, 'PAMC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (62.97, -141.94, 'PAOR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.0186, -154.358, 'PAFS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.033, -145.5, 'PAXK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.41, -148.95, 'PATW');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.4901, -162.11, 'PAMK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.69, -170.5, 'PASA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.73, -148.92, 'PAIN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.77, -171.74, 'PAGM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.89, -149.02, 'PAHV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.89, -160.81, 'PAUN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.91, -152.16, 'PAMH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (63.97, -145.7, 'PABI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (64.33, -158.75, 'PAKV');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (64.5, -165.44, 'PAOM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (64.54, -163.04, 'PAGL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (64.5473, -149.074, 'PANN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (64.65, -147.067, 'PAEI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (64.7272, -155.47, 'PARY');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (64.74, -156.94, 'PAGA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (64.78, -141.15, 'PAEG');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (64.82, -147.87, 'PAFA');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (64.833, -147.617, 'PAFB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (64.93, -165.15, 'PAKK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (65, -150.65, 'PAML');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (65.17, -152.1, 'PATA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (65.57, -144.77, 'PARL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (65.57, -167.92, 'PATC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (65.5739, -144.781, 'PACE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (65.6979, -156.351, 'PAHL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (65.7, -156.39, 'PAHS');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (65.99, -161.12, 'PABL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (66, -153.7, 'PAIM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (66.08, -162.75, 'PADE');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (66.27, -166.05, 'PASH');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (66.57, -145.27, 'PFYU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (66.62, -160, 'PASK');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (66.817, -150.65, 'PAPR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (66.87, -162.64, 'PAOT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (66.92, -151.52, 'PABT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (67.1, -157.85, 'PAFM');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (67.5, -148.49, 'PALR');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (67.57, -162.98, 'PAWN');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (67.73, -164.55, 'PAVL');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (68.08, -162.83, 'PARD');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (68.12, -145.57, 'PARC');", 

		                    "insert into StationList (latitude, longitude, xml_url) values (68.13, -151.73, 'PAKP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (68.35, -166.81, 'PAPO');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (68.49, -149.49, 'PAGB');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (68.89, -166.14, 'PALU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (69.73, -163.02, 'PPIZ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (70.14, -143.59, 'PABA');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (70.2, -148.47, 'PASC');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (70.21, -151.01, 'PAQT');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (70.317, -149.583, 'PAKU');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (70.3443, -150.945, 'PALP');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (70.4673, -157.436, 'PATQ');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (70.62, -159.86, 'PAWI');", 
		                    "insert into StationList (latitude, longitude, xml_url) values (71.29, -156.77, 'PABR');"
		                    ];

		document.getElementById('divMenu').style.display = 'none';
		document.getElementById('divToday').style.display = 'none';
		document.getElementById('divSevenDays').style.display = 'none';
		document.getElementById('divShortTerm').style.display = 'none';
		document.getElementById('divSettings').style.display = 'none';
		document.getElementById('divManageLocation').style.display = 'none';
		document.getElementById('divAddLocation').style.display = 'block';

		var currentDate = new Date().toString();
		var arrLength = stationsList.length;
		increment = 98 / arrLength;

		for (var i=0; i<arrLength; i++) {
			tx.executeSql(stationsList[i], null, incrementPercent);
		}

		tx.executeSql("insert into Preferences(PrefOption, PrefValue1) values ('LastUpdatedStationList', ?);", [currentDate]);
		tx.executeSql("insert into Preferences(PrefOption, PrefValue1) values ('DBCreatedOn', '15 Aug 2010');", null, progressComplete);

		createAddLocationMenu();  // Move this.
	}
	catch(ex)
	{
		errMessage = errMessage + "\n insertDefaultStations() : " + ex;
	}
	showErrorsToDev();
}
